#include <p32xxxx.h>
#include <plib.h>
#include <stdio.h>
#include "System.h"

#define Timer1Tick ( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec 2

void main(void)
{
    InitializeSystem();

    // 使用XC32 I/O Prot Function將LED(RD2, RD5)對應之I/O設定成數位輸出，
    // 並指定I/O Port狀態。
    mPORTDSetPinsDigitalOut(BIT_2 | BIT_5);
    mPORTDClearBits(BIT_2 | BIT_5);

    // 使用XC32 I/O Prot Function將Button(RF4)對應之I/O設定成數位輸入，
    mPORTFSetPinsDigitalIn(BIT_4);

    // 使用XC32 OpenTimer1 Function 設定Timer1。
    OpenTimer1(T1_ON | T1_GATE_OFF | T1_PS_1_256 |
               T1_SOURCE_INT, Timer1Tick);

    // To Do : 使用XC32 ConfigIntTimer1 Function啟用Timer1中斷
    //         並指定其主要中斷優先權為4，次要優先權為0。
    ConfigIntTimer1(T1_INT_???? | T1_INT_PRIOR_???? | T1_INT_SUB_PRIOR_????);

    // To Do : 使用XC32 INTEnableSystemMultiVectoredInt Function
    //         設定為PIC32為多重中斷向量模式。
    INTEnableSystem????VectoredInt();

    while (1)
    {
        // 使用XC32 I/O Prot Function 讀取按鍵(BT1, RF4)狀態，
        // 並反應到LED(D11, RD5)上。
        if (mPORTFReadBits(BIT_4))
            mPORTDClearBits(BIT_5);
        else
            mPORTDSetBits(BIT_5);
    }
}

// To Do : 建立Timer1的中斷服務函式，並指定主要中斷優先權為4。
void __ISR(_TIMER_????_VECTOR, ipl????) ISR_Timer1(void)
{
    // To Do : 清除Timer中斷旗標。
    INTClearFlag(INT_T????);

    // 使用XC32 I/O Prot Function改變IO Port(RD2)狀態(Toggle)。
    mPORTDToggleBits(BIT_2);
}
