#include <p32xxxx.h>
#include <plib.h>
#include <stdio.h>
#include "System.h"

#define Timer1Tick ( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec 2

unsigned int VR1Value = 0;
unsigned int VR2Value = 0;

void main(void)
{
    InitializeSystem();

	mPORTDSetPinsDigitalOut(BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_2 | BIT_3 | BIT_4 | BIT_5);
    mPORTDClearBits(BIT_8 | BIT_9 | BIT_10 | BIT_11);
    mPORTDSetBits(BIT_2 | BIT_3 | BIT_4 | BIT_5);

    OpenTimer1(T1_ON | T1_GATE_OFF | T1_PS_1_256 |
               T1_SOURCE_INT, Timer1Tick);

    ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_4 | T1_INT_SUB_PRIOR_0);

    OpenADC10(ADC_MODULE_ON | ADC_IDLE_CONTINUE | ADC_FORMAT_INTG16 | ADC_CLK_MANUAL | ADC_AUTO_SAMPLING_ON | ADC_SAMP_OFF,
              ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_ON | ADC_SAMPLES_PER_INT_2 | ADC_ALT_BUF_OFF | ADC_ALT_INPUT_OFF,
              ADC_SAMPLE_TIME_31 | ADC_CONV_CLK_SYSTEM | ADC_CONV_CLK_32Tcy,
              ENABLE_AN19_ANA | ENABLE_AN18_ANA,
              SKIP_SCAN_AN0 | SKIP_SCAN_AN1 | SKIP_SCAN_AN2 | SKIP_SCAN_AN3 |
              SKIP_SCAN_AN4 | SKIP_SCAN_AN5 | SKIP_SCAN_AN6 | SKIP_SCAN_AN7 |
              SKIP_SCAN_AN8 | SKIP_SCAN_AN9 | SKIP_SCAN_AN10 | SKIP_SCAN_AN11 |
              SKIP_SCAN_AN12 | SKIP_SCAN_AN13 | SKIP_SCAN_AN14 | SKIP_SCAN_AN15 |
              SKIP_SCAN_AN16 | SKIP_SCAN_AN17 |
              SKIP_SCAN_AN20 | SKIP_SCAN_AN21 | SKIP_SCAN_AN22 | SKIP_SCAN_AN23 |
              SKIP_SCAN_AN24 | SKIP_SCAN_AN25 | SKIP_SCAN_AN26 | SKIP_SCAN_AN27 |
              SKIP_SCAN_AN28 | SKIP_SCAN_AN29 | SKIP_SCAN_AN30 );

    INTEnableSystemMultiVectoredInt();

    while (1)
    {
        if (INTGetFlag(INT_AD1))
        {
            VR2Value = (unsigned int) ReadADC10(0);
            VR1Value = (unsigned int) ReadADC10(1);

             INTClearFlag(INT_AD1);

            printf("Demo Application : VR1 Value = %4d , VR2 Value = %4d , BT1 = %1d \r\n" ,
                   VR1Value , VR2Value , !(( mPORTFReadBits(BIT_4) ) >> 4) );
        }
    }
}

void __ISR(_TIMER_1_VECTOR, ipl4) ISR_Timer1(void)
{
    // 清除Timer中斷旗標。
    INTClearFlag(INT_T1);

    ConvertADC10();

    mPORTDToggleBits(BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_2 | BIT_3 | BIT_4 | BIT_5);
}
