#include <p32xxxx.h>
#include <plib.h>
#include <stdio.h>
#include "System.h"

//#define USE_Polling
#define USE_State_Machine

void main(void)
{
    unsigned int i = 0;

    InitializeSystem();

    // To Do : 使用XC32 I/O Prot Function將LED(RD2, RD5)對應之I/O設定成數位輸出，
    //         並指定I/O Port狀態。
    mPORTDSetPinsDigitalOut(BIT_2 | BIT_5);
    mPORTDClearBits(BIT_2 | BIT_5);

    //  To Do : 使用XC32 I/O Prot Function將Button(RF4)對應之I/O設定成數位輸入，
    mPORTFSetPinsDigitalIn(BIT_4);

    #if defined (USE_Polling)
    while (1)
    {
        // To Do : 完成延遲副程式，使LED變化可以被人眼所察覺。
        for (i = 0; i < 200000L; i++)
            Nop();

        // 使用XC32 I/O Prot Function改變IO Port(RD2)狀態(Toggle)。
        mPORTDToggleBits(BIT_2);

        // To Do : 使用XC32 I/O Prot Function讀取IO Port(RF4)狀態，
        //         並改變LED(RD5)狀態。
        if(mPORTFReadBits(BIT_4))
            mPORTDClearBits(BIT_5);
        else
            mPORTDSetBits(BIT_5);
    }

    #elif defined (USE_State_Machine)
    while (1)
    {
        // To Do : 改用狀態機的方式完成延遲，使LED變化可以被人眼所察覺。
        if (i++ >= 100000L )
        {
            i = 0;

            // 使用XC32 I/O Prot Function改變IO Port(RD2)狀態(Toggle)。
            mPORTDToggleBits(BIT_2);
        }

        // To Do : 使用XC32 I/O Prot Function 讀取按鍵(BT1, RF4)狀態，
        //         並反應到LED(D11, RD5)上。
        if(mPORTFReadBits(BIT_4))
            mPORTDClearBits(BIT_5);
        else
            mPORTDSetBits(BIT_5);
    }
    #endif
}
