#include <p32xxxx.h>
#include <plib.h>
#include <stdio.h>
#include "System.h"

void main(void)
{
    unsigned int i = 0;

    InitializeSystem();

    // 使用XC32 I/O Prot Function將LED(RD2, RD5)對應之I/O設定成數位輸出，
    // 並指定I/O Port狀態。
    mPORTDSetPinsDigitalOut(BIT_2 | BIT_5);
    mPORTDClearBits(BIT_2 | BIT_5);

    // 使用XC32 I/O Prot Function將Button(RF4)對應之I/O設定成數位輸入，
    mPORTFSetPinsDigitalIn(BIT_4);

    while (1)
    {
        // To Do : 因應系統時脈改變，重新設定延遲時間，使LED變化可以被人眼所察覺。
        if (i++ >= 2000000L ) // 100000 * 20
        {
            i = 0;

            // 使用XC32 I/O Prot Function改變IO Port(RD2)狀態(Toggle)。
            mPORTDToggleBits(BIT_2);
        }

        // 使用XC32 I/O Prot Function 讀取按鍵(BT1, RF4)狀態，
        // 並反應到LED(D11, RD5)上。
        if(mPORTFReadBits(BIT_4))
            mPORTDClearBits(BIT_5);
        else
            mPORTDSetBits(BIT_5);
    }
}
