#include <p32xxxx.h>
#include <plib.h>
#include <stdio.h>
#include "System.h"

#define Timer1Tick ( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec 2

void main(void)
{
    InitializeSystem();

    // 使用XC32 I/O Prot Function將LED(RD2, RD5)對應之I/O設定成數位輸出，
    // 並指定I/O Port狀態。
    mPORTDSetPinsDigitalOut(BIT_2 | BIT_5);
    mPORTDClearBits(BIT_2 | BIT_5);

    // 使用XC32 I/O Prot Function將Button(RF4)對應之I/O設定成數位輸入，
    mPORTFSetPinsDigitalIn(BIT_4);

    // To Do : 使用XC32 OpenTimer1 Function 設定Timer1。
    OpenTimer1(T1_ON | T1_GATE_OFF | T1_PS_1_256 |
               T1_SOURCE_INT, Timer1Tick);

    while (1)
    {
        // To Do : 判斷Timer1中斷旗標。
        if (INTGetFlag(INT_T1))
        {
            // To Do : 清除Timer1中斷旗標。
            INTClearFlag(INT_T1);

            // 使用XC32 I/O Prot Function改變IO Port(RD2)狀態(Toggle)。
            mPORTDToggleBits(BIT_2);
        }

        // 使用XC32 I/O Prot Function 讀取按鍵(BT1, RF4)狀態，
        // 並反應到LED(D11, RD5)上。
        if(mPORTFReadBits(BIT_4))
            mPORTDClearBits(BIT_5);
        else
            mPORTDSetBits(BIT_5);
    }
}
